Index: soft/giet_vm/giet_boot/boot.c
===================================================================
--- soft/giet_vm/giet_boot/boot.c	(revision 490)
+++ soft/giet_vm/giet_boot/boot.c	(revision 493)
@@ -2323,135 +1977,165 @@
     mapping_header_t*  header     = (mapping_header_t *)SEG_BOOT_MAPPING_BASE;
     mapping_cluster_t* cluster    = _get_cluster_base(header);
+
     unsigned int       gpid       = _get_procid();
-    unsigned int       clusterid, p;
-
-    if ( gpid == 0 )    // only Processor 0 does it
-    {
-        _puts("\n[BOOT] boot_init start at cycle ");
-        _putd(_get_proctime());
-        _puts("\n");
+    unsigned int       cx         = gpid >> (Y_WIDTH + P_WIDTH);
+    unsigned int       cy         = (gpid >> P_WIDTH) & ((1<<Y_WIDTH)-1);
+    unsigned int       lpid       = gpid & ((1 << P_WIDTH) -1);
+    unsigned int       cluster_id = (cx * Y_SIZE) + cy;
+
+    // Phase ONE : only P[0][0][0] execute it
+    if ( gpid == 0 )    
+    {
+        unsigned int cid;  // index for loops 
+
+        // initialises the TTY0 spin lock
+        _spin_lock_init( &_tty0_spin_lock );
+
+        _printf("\n[BOOT] P[0,0,0] starts at cycle %d\n", _get_proctime() );
 
         // initialises the FAT
         _fat_init( IOC_BOOT_MODE );
 
-        _puts("\n[BOOT] Fat initialised at cycle ");
-        _putd(_get_proctime());
-        _puts("\n");
-        // Load the map.bin file into memory and check it
+        _printf("\n[BOOT] FAT initialised at cycle %d\n", _get_proctime() );
+
+        // Load the map.bin file into memory 
         boot_mapping_init();
 
-        _puts("\n[BOOT] Mapping \"");
-        _puts( header->name );
-        _puts("\" loaded at cycle ");
-        _putd(_get_proctime());
-        _puts("\n");
-
-        _barrier_init(&barrier_boot, X_SIZE*Y_SIZE);
-
-        for ( clusterid = 1 ; clusterid < X_SIZE*Y_SIZE ; clusterid++ ) 
-        {
-            unsigned int x          = cluster[clusterid].x;
-            unsigned int y          = cluster[clusterid].y;
-            unsigned int cluster_xy = (x<<Y_WIDTH) + y;
-
-            _xcu_send_wti_paddr( cluster_xy, 0, (unsigned int)boot_entry );
-        }
-    }
-    //Parallel phase to construct the ptab by each processor[x][y][0] 
-    if( (gpid & ((1 << P_WIDTH) -1)) == 0)
-    {
-        // Initializes the physical memory allocators
-        boot_pmem_init();
-        // Build ge tables
-        boot_ptabs_init();
-        //wait for all processors finished the work
-        _barrier_wait(&barrier_boot);
-
-        if( gpid ) while( boot_init_ok == 0);
-    }
-
-    if ( gpid == 0 )    // only Processor 0 does it
-    {
-        _puts("\n[BOOT] Physical memory allocators and Page table initialized at cycle ");
-        _putd(_get_proctime());
-        _puts("\n");
-
-        // Activate MMU for proc [0,0,0]
-        _set_mmu_ptpr( (unsigned int)(_ptabs_paddr[0][0][0]>>13) );
+        _printf("\n[BOOT] Mapping %s loaded at cycle %d\n",
+                header->name , _get_proctime() );
+
+        // initialises the barrier for all clusters containing processors
+        unsigned int nclusters = 0;
+        for ( cid = 0 ; cid < X_SIZE*Y_SIZE ; cid++ )
+        {
+            if ( cluster[cid].procs ) nclusters++ ;
+        } 
+
+        _simple_barrier_init( &_barrier_all_clusters , nclusters );
+
+        // wake up all processors P[x][y][0]
+        for ( cid = 1 ; cid < X_SIZE*Y_SIZE ; cid++ ) 
+        {
+            unsigned int x          = cluster[cid].x;
+            unsigned int y          = cluster[cid].y;
+            unsigned int cluster_xy = (x << Y_WIDTH) + y;
+
+            if ( cluster[cid].procs ) 
+            {
+                unsigned long long paddr = (((unsigned long long)cluster_xy)<<32) +
+                                           SEG_XCU_BASE + XCU_REG( XCU_WTI_REG , 0 );
+
+                _physical_write( paddr , (unsigned int)boot_entry );
+            }
+        }
+
+        _printf("\n[BOOT] Processors P[x,y,0] start at cycle %d\n", _get_proctime() );
+    }
+
+    // Phase TWO : All processors P[x][y][0] execute it in parallel
+    if( lpid == 0 )
+    {
+        // Initializes physical memory allocator in cluster[cx][cy]
+        boot_pmem_init( cx , cy );
+
+        // Build page table in cluster[cx][cy]
+        boot_ptab_init( cx , cy );
+
+        //////////////////////////////////////////////
+        _simple_barrier_wait( &_barrier_all_clusters );
+        //////////////////////////////////////////////
+
+        // P[0][0][0] complete page tables with vsegs 
+        // mapped in clusters without processors 
+        if ( gpid == 0 )   
+        {
+            // complete page tables initialisation
+            boot_ptab_extend();
+
+            _printf("\n[BOOT] Physical memory allocators and page tables"
+                    " initialized at cycle %d\n", _get_proctime() );
+        }
+
+        //////////////////////////////////////////////
+        _simple_barrier_wait( &_barrier_all_clusters );
+        //////////////////////////////////////////////
+
+        // All processors P[x,y,0] activate MMU (using local PTAB) 
+        _set_mmu_ptpr( (unsigned int)(_ptabs_paddr[0][cx][cy]>>13) );
         _set_mmu_mode( 0xF );
-
-        _puts("\n[BOOT] Processor[0,0,0] : MMU activation at cycle ");
-        _putd(_get_proctime());
-        _puts("\n");
-
-        // Initialise private vobjs in vspaces
-        boot_vobjs_init();
-
-        _puts("\n[BOOT] Private vobjs initialised at cycle ");
-        _putd(_get_proctime());
-        _puts("\n");
-  
-        // Initialise schedulers
-        boot_schedulers_init();
-
-        _puts("\n[BOOT] Schedulers initialised at cycle ");
-        _putd(_get_proctime());
-        _puts("\n");
         
-        // Set CP0_SCHED register for proc [0,0,0]
-        _set_sched( (unsigned int)_schedulers[0][0][0] );
-
-        // Initialise non replicated peripherals
-        boot_peripherals_init();
-
-        _puts("\n[BOOT] Non replicated peripherals initialised at cycle ");
-        _putd(_get_proctime());
-        _puts("\n");
-
-        // Loading all .elf files
-        boot_elf_load();
-
-        // wake up the processors which has constructed the ptab before
-        boot_init_ok = 1;
-
-        for ( clusterid = 0 ; clusterid < X_SIZE*Y_SIZE ; clusterid++ ) 
-        {
-            unsigned int nprocs     = cluster[clusterid].procs;
-            unsigned int x          = cluster[clusterid].x;
-            unsigned int y          = cluster[clusterid].y;
-            unsigned int cluster_xy = (x<<Y_WIDTH) + y;
-
-            for ( p = 1 ; p < nprocs; p++ ) 
+        // Each processor P[x,y,0] initialises all schedulers in cluster[x,y]
+        boot_scheduler_init( cx , cy );
+
+        // Each processor P[x][y][0] initialises its CP0_SCHED register
+        _set_sched( (unsigned int)_schedulers[cx][cy][0] );
+
+        //////////////////////////////////////////////
+        _simple_barrier_wait( &_barrier_all_clusters );
+        //////////////////////////////////////////////
+        
+        // Processor P[0,0,0] completes schedulers with PIC-WTI 
+        // initialises external peripherals and load .elf files.
+        if ( gpid == 0 ) 
+        {
+            // complete schedulers initialisation
+            boot_pic_wti_init();
+
+            _printf("\n[BOOT] Schedulers initialised at cycle %d\n", _get_proctime() );
+
+            // initialize non replicated peripherals
+            boot_peripherals_init();
+
+            _printf("\n[BOOT] Peripherals initialised at cycle %d\n", _get_proctime() );
+
+            // Loading all .elf files
+            boot_elf_load();
+        }
+/*  
+        // Each processor P[x][y][0] checks sequencially its local page table
+        unsigned int seq_x;
+        unsigned int seq_y;
+        for ( seq_x = 0 ; seq_x < X_SIZE ; seq_x++ )
+        {
+            for ( seq_y = 0 ; seq_y < Y_SIZE ; seq_y++ )
             {
-                _xcu_send_wti( cluster_xy, p, (unsigned int)boot_entry );
+                if ( (cx == seq_x) && (cy == seq_y) ) boot_ptab_check( cx , cy );
+                
+                //////////////////////////////////////////////
+                _simple_barrier_wait( &_barrier_all_clusters );
+                //////////////////////////////////////////////
             }
         }
-    }  // end monoprocessor boot
-
-    ///////////////////////////////////////////////////////////////////////////////
-    //            Parallel execution starts actually here
-    ///////////////////////////////////////////////////////////////////////////////
-
-    // all processor initialise the SCHED register
-    // from the _schedulers[x][y][lpid array]
-    unsigned int cluster_xy = gpid >> P_WIDTH;
-    unsigned int lpid       = gpid & ((1<<P_WIDTH)-1);
-    unsigned int x          = cluster_xy >> Y_WIDTH;
-    unsigned int y          = cluster_xy & ((1<<Y_WIDTH)-1);
-    _set_sched( (unsigned int)_schedulers[x][y][lpid] );
-
-    // all processors (but Proc[0,0,0]) activate MMU
-    if ( gpid != 0 )
-    {
-        _set_mmu_ptpr( (unsigned int)(_ptabs_paddr[0][x][y]>>13) );
+*/          
+        //////////////////////////////////////////////
+        _simple_barrier_wait( &_barrier_all_clusters );
+        //////////////////////////////////////////////
+        
+        // each processor P[x][y][0] wake up other processors in same cluster
+        unsigned int cluster_xy = (cx << Y_WIDTH) + cy;
+        unsigned int p;
+        for ( p = 1 ; p < cluster[cluster_id].procs ; p++ )
+        {
+            _xcu_send_wti( cluster_xy , p , (unsigned int)boot_entry );
+        }
+
+        if ( gpid == 0 )    // only P[0][0][0] makes display
+        _printf("\n[BOOT] All processors start at cycle %d\n", _get_proctime() );
+    }
+
+    // Other processors than P[x][y][0] activate MMU (using local PTAB)
+    if ( lpid != 0 )
+    {
+        _set_mmu_ptpr( (unsigned int)(_ptabs_paddr[0][cx][cy]>>13) );
         _set_mmu_mode( 0xF );
     }
 
-    // all processors reset BEV bit in the status register to use
-    // the GIET_VM exception handler instead of the PRELOADER exception handler
+    // All processors set CP0_SCHED register 
+    _set_sched( (unsigned int)_schedulers[cx][cy][lpid] );
+
+    // All processors reset BEV bit in SR to use GIET_VM exception handler 
     _set_sr( 0 );
 
-    // all processors jump to kernel_init 
-    // using the address defined in the giet_vsegs.ld file
+    // All processors jump to kernel_init 
     unsigned int kernel_entry = (unsigned int)&kernel_init_vbase;
     asm volatile( "jr   %0" ::"r"(kernel_entry) );
